﻿<%@ Page Language="C#"%>

<%
	string _Username = "DefaultUsername";
	string _Password = "DefaultPassword";
	string _Directory = "";

	bool IsValidComputerName(string ComputerName)
	{ return !ComputerName.Contains("..") && (ComputerName.IndexOfAny("<>:\"/\\|?`*".ToCharArray()) == -1); }

	string ToPath(string ComputerName, string DriveName)
	{ return Server.MapPath(string.Format("{0}{1} {2}.hbulkey", _Directory, ComputerName, Convert.ToBase64String(System.Text.Encoding.UTF8.GetBytes(DriveName)).Replace('/', '_'))); }

	int GetPassword(string ComputerName, string DriveName, out string Password)
	{
		if(!IsValidComputerName(ComputerName))
		{ Password = ""; return -1; }
		else
		{ Password = System.IO.File.ReadAllText(ToPath(ComputerName, DriveName), System.Text.Encoding.UTF8); return 0; }
	}

	int InsertPassword(string ComputerName, string DriveName, string Password)
	{
		if(!IsValidComputerName(ComputerName))
			return -1;
		else
		{ System.IO.File.WriteAllText(ToPath(ComputerName, DriveName), Password, System.Text.Encoding.UTF8); return 0; }
	}

	int DeletePassword(string ComputerName, string DriveName)
	{
		if(!IsValidComputerName(ComputerName))
			return -1;
		else
		{ System.IO.File.Delete(ToPath(ComputerName, DriveName)); return 0; }
	}

	if((System.Uri.UnescapeDataString(Request["username"]) != _Username)
	|| (System.Uri.UnescapeDataString(Request["password"]) != _Password))
	{
		Response.Write("access denied");
		Response.StatusCode = 500;
	}
	else
	{
		switch(Request["function"])
		{
		case "GetPassword":
			string Password;
			Response.Write(GetPassword(
				System.Uri.UnescapeDataString(Request["computername"]),
				System.Uri.UnescapeDataString(Request["drivename"]),
				out Password).ToString());
			Response.Write(";");
			Response.Write(Password);
			break;

		case "InsertPassword":
			Response.Write(InsertPassword(
				System.Uri.UnescapeDataString(Request["computername"]),
				System.Uri.UnescapeDataString(Request["drivename"]),
				System.Uri.UnescapeDataString(Request["drivepassword"])).ToString());
			break;

		case "DeletePassword":
			Response.Write(DeletePassword(
				System.Uri.UnescapeDataString(Request["computername"]),
				System.Uri.UnescapeDataString(Request["drivename"])).ToString());
			break;

		default:
			Response.Write("function not found");
			Response.StatusCode = 500;
			break;
		}
	}
%>

