<?php

	const _Username = "DefaultUsername";
	const _Password = "DefaultPassword";
	const _Directory = "";

	function IsValidComputerName($ComputerName)
	{ return !strpos($ComputerName, '..') && !strpbrk($ComputerName, '<>:\"/\\|?`*'); }

	function ToPath($ComputerName, $DriveName)
	{ return dirname(__FILE__) . '\\' . _Directory . $ComputerName . ' ' . str_replace('/', '_', base64_encode(utf8_encode($DriveName))) . '.hbulkey'; }

	function GetPassword($ComputerName, $DriveName, &$Password)
	{
		if(!IsValidComputerName($ComputerName))
		{ $Password = ""; return -1; }
		else
		{ $Password = file_get_contents(ToPath($ComputerName, $DriveName)); return 0; }
	}

	function InsertPassword($ComputerName, $DriveName, $Password)
	{
		if(!IsValidComputerName($ComputerName))
			return -1;
		else
		{ file_put_contents(ToPath($ComputerName, $DriveName), utf8_encode($Password)); return 0; }
	}

	function DeletePassword($ComputerName, $DriveName)
	{
		if(!IsValidComputerName($ComputerName))
			return -1;
		else
		{ unlink(ToPath($ComputerName, $DriveName)); return 0; }
	}

	if((rawurldecode($_POST['username']) != _Username)
	|| (rawurldecode($_POST['password']) != _Password))
	{
		echo "access denied";
		http_response_code(500);
	}
	else
	{
		switch($_POST['function'])
		{
		case "GetPassword":
			$Password;
			echo GetPassword(
				rawurldecode($_POST['computername']),
				rawurldecode($_POST['drivename']),
				$Password);
			echo ";";
			echo $Password;
			break;

		case "InsertPassword":
			echo InsertPassword(
				rawurldecode($_POST['computername']),
				rawurldecode($_POST['drivename']),
				rawurldecode($_POST['drivepassword']));
			break;

		case "DeletePassword":
			echo DeletePassword(
				rawurldecode($_POST['computername']),
				rawurldecode($_POST['drivename']));
			break;

		default:
			echo "function not found";
			http_response_code(500);
			break;
		}
	}

?>